package com.jkcredit.identity.config.properties;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;

@Data
@ConfigurationProperties(prefix = "ab.http")
public class HttpClientProperties {

    // Determines the timeout in milliseconds until a connection is established.
    private int connectTimeout = 30000;

    // The timeout when requesting a connection from the connection manager.
    private int requestTimeout = 30000;

    // The timeout for waiting for data
    private int socketTimeout = 60000;

    private int maxTotalConnections = 50;
    private int defaultKeepAliveTimeMillis = 20 * 1000;
    private int closeIdleConnectionWaitTimeSecs = 30;
}
